#!/usr/bin/bash

shopt -s nullglob globstar

typeit=0
if [[ $1 == "--type" ]]; then
	typeit=1
	shift

	if [[ -n $WAYLAND_DISPLAY ]] && command -v ydotool &> /dev/null; then
		xdotool="ydotool type --file -"
elif [[ -n $DISPLAY ]] && command -v xdotool &> /dev/null; then
		xdotool="xdotool type --clearmodifiers --file -"
	else
		echo "Error: No Wayland or X11 display and command-line automation tool detected" >&2
		exit 1
	fi
fi

if [[ -n $WAYLAND_DISPLAY ]] && command -v dmenu-wl &> /dev/null; then
	dmenu=dmenu-wl
elif [[ -n $DISPLAY ]] && command -v dmenu &> /dev/null; then
	dmenu=dmenu
else
	echo "Error: No Wayland or X11 display and dynamic menu detected" >&2
	exit 1
fi

prefix=${PASSWORD_STORE_DIR-~/.password-store}
password_files=( "$prefix"/**/*.gpg )
password_files=( "${password_files[@]#"$prefix"/}" )
password_files=( "${password_files[@]%.gpg}" )

password=$(printf '%s\n' "${password_files[@]}" | "$dmenu" "$@")

[[ -n $password ]] || exit

if [[ $typeit -eq 0 ]]; then
	pass show -c "$password" 2>/dev/null
else
	pass show "$password" | { IFS= read -r pass; printf %s "$pass"; } | $xdotool
fi
